#!/bin/bash

##################################
# PIN DEFINITION
##################################
GPIO_SHUTDOWN_NOTIFY_PIN=17
GPIO_REQUEST_DETECT_PIN=4

##################################
# Rise up shutdown notify pin 
##################################
if [ ! -e /sys/class/gpio/gpio$GPIO_SHUTDOWN_NOTIFY_PIN ]; then
    echo $GPIO_SHUTDOWN_NOTIFY_PIN > /sys/class/gpio/export
    if [ $? -ne 0 ]; then
        exit 1
    fi
    sleep 1
    while [ ! -e /sys/class/gpio/gpio$GPIO_SHUTDOWN_NOTIFY_PIN/direction ]
    do
        sleep 0.2
    done
    echo out > /sys/class/gpio/gpio$GPIO_SHUTDOWN_NOTIFY_PIN/direction
    if [ $? -ne 0 ]; then
        exit 1
    fi
    echo 1 > /sys/class/gpio/gpio$GPIO_SHUTDOWN_NOTIFY_PIN/value
fi


##################################
# Wait shutdown request and shutdown
##################################
if [ ! -e /sys/class/gpio/gpio$GPIO_REQUEST_DETECT_PIN ]; then
    echo $GPIO_REQUEST_DETECT_PIN > /sys/class/gpio/export
    if [ $? -ne 0 ]; then
        exit 1
    fi
    sleep 1
    while [ ! -e /sys/class/gpio/gpio$GPIO_REQUEST_DETECT_PIN/direction ]
    do
        sleep 0.2
    done
    echo in > /sys/class/gpio/gpio$GPIO_REQUEST_DETECT_PIN/direction
    if [ $? -ne 0 ]; then
        exit 1
    fi
fi

while :
do
    pin_state=`cat /sys/class/gpio/gpio$GPIO_REQUEST_DETECT_PIN/value`
    if [ $pin_state -eq 0 ]; then
        shutdown -h now
        exit 1
    fi
    sleep 0.5
done

